/** Rill v0.0.584 https://www.npmjs.com/package/rill License: MIT*/
"use strict";
var Cookies, Request, expect, parseURL;

Cookies = require("@rill/cookies");

parseURL = require("@rill/parse-url");

expect = require("./util/expect");


/*
 * Constructor that will normalize a request object.
#
 * @param {Object} req
 * @constructor
 */

Request = (function() {
  function Request(req) {
    var defaults, key, ref, ref1, ref2, ref3, ref4, ref5, ref6, ref7, ref8, ref9, val;
    if (!(this instanceof Request)) {
      return new Request(req);
    }
    expect(req != null, "Could not create Request with an empty object.");
    expect(req.url != null, "Could not create a Request without a URL.");
    this.req = req;
    this.body = (ref = req.body) != null ? ref : {};
    this.files = (ref1 = req.files) != null ? ref1 : [];
    this.headers = (ref2 = req.headers) != null ? ref2 : {};
    this.method = ((ref3 = req.method) != null ? ref3 : "GET").toUpperCase();
    {
      this.ip = "127.0.0.1";
      this.headers.cookie = document.cookie;
      defaults = location;
    }
    this.cookies = new Cookies(this.headers.cookie);
    ref9 = parseURL(req.url, defaults);
    for (key in ref9) {
      val = ref9[key];
      this[key] = val;
    }
  }


  /*
  	 * Trigger another request that will redirect the browser and send a location change on the server.
  	 * If "back" is the url then it will attempt to redirect the user back a url, otherwise the alt will be used.
  	#
  	 * @param {String} url
  	 * @param {String} alt
   */

  Request.prototype.redirect = function(url, alt) {
    if (url == null) {
      url = "back";
    }
    if (alt == null) {
      alt = "/";
    }
    if (this.mounted) {
      if (alt[0] === "/") {
        alt = this.mounted + alt;
      }
      if (url[0] === "/") {
        url = this.mounted + url;
      }
    }
    return this.redirectURL = (url !== "back" ? url : this.headers.referer || alt);
  };

  return Request;

})();

module.exports = Request;
