/** Rill v0.0.584 https://www.npmjs.com/package/rill License: MIT*/
"use strict";
var expect, noop;

expect = require("./expect");

noop = function*() {
  return;
};


/*
 * Compose `middleware` returning
 * a fully valid middleware comprised
 * of all those which are passed.
#
 * @param {Array} middleware
 * @return {Function}
 * @api private
 */

module.exports = function(middleware) {
  if (!middleware || middleware.length === 0) {
    return noop;
  }
  if (middleware.length === 1) {
    return middleware[0];
  }
  return function*(req, res, next) {
    var i;
    if (next == null) {
      next = noop;
    }
    i = middleware.length;
    while (i--) {
      next = middleware[i].call(this, req, res, next);
    }
    return (yield* next);
  };
};
