expect = require("./expect")
noop   = -> yield return

###
# Compose `middleware` returning
# a fully valid middleware comprised
# of all those which are passed.
#
# @param {Array} middleware
# @return {Function}
# @api private
###
module.exports = (middleware)->
	return noop if not middleware or middleware.length is 0
	return middleware[0] if middleware.length is 1
	return (req, res, next = noop)->
		i    = middleware.length
		next = middleware[i].call(@, req, res, next) while i--
		return yield from next